<?php 

setlocale(LC_TIME, 'de_DE.utf8');

if ($_GET['day']){
    $selected_day = $_GET['day'];
    $daylabel = 'Tag';
} else {
    $selected_day = date("Y-m-d");
    $daylabel = 'Heute';
}

require_once "sleekdb/SleekDB.php";

$databaseDirectory = __DIR__ . "/db";

$date_today = date("Y-m-d");
$monthtoday = date("Y-m");

$dateFormatted = strftime("%A, %e. %B %Y", strtotime($selected_day)); 
$currentmonth = strftime("%B", strtotime($selected_day)); 
$currentyear = strftime("%Y", strtotime($selected_day)); 

$one_day_before = date("Y-m-d", strtotime($selected_day . " -1 day"));
$one_day_after = date("Y-m-d", strtotime($selected_day . " +1 day"));

$p = 0;
$e = 0;

$power_data_store = new \SleekDB\Store("power_data", $databaseDirectory);

$data = $power_data_store->findBy(["date", "=", $selected_day],["_id" => "desc"]);
$count = count($data);

$lastreload = '';

if ($count > 0){
    $zeitpunkt1 = DateTime::createFromFormat('H.i', end($data[0])['time']);
    $zeitpunkt2 = DateTime::createFromFormat('H.i', date("H.i"));
    $interval = $zeitpunkt1->diff($zeitpunkt2);

    $lastreload = '(vor ';
    if  ($interval->format('%H') > 0){
        $lastreload .= $interval->format('%h').' Stunden und ';
    }
    $lastreload .= $interval->format('%i').' Minuten)';
 

if (end($data[0])["p"]){ $p = end($data[0])["p"]; } 
if (end($data[0])["e"]){ $e = number_format(end($data[0])["e"], 2); } 

if (end($data[0])["te"]){ 
    $te = number_format(end($data[0])["te"], 2); 
} else {  
    $dateyesterday = date("Y-m-d", strtotime("-1 days"));
    $yesterdaystore = new \SleekDB\Store("power_data", $databaseDirectory);
    $yesterdaydata = $yesterdaystore->findBy(["date", "=", $dateyesterday],["_id" => "desc"]);
    $te = number_format($yesterdaydata[0]["te"], 2); 
}

}

$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);
$month_data = $currentstore->findBy(["month", "=", $monthtoday],["_id" => "desc"],1);
$total_sun_month = number_format($month_data[0]['total_sun_month'], 2); 

$total_sun_day = 0;

$total_sun_day = number_format($month_data[0][$selected_day]['total_sun_day'], 2);

?>

<!doctype html>
<html lang="de">

<head>
    <title>Solar Power</title>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, viewport-fit=cover, initial-scale=1.0">
    <meta name="robots" content="noindex, nofollow">
    <meta name="language" content="de">
    <?php if ($selected_day == $date_today) { ?>
    <meta http-equiv="refresh" content="300">
    <?php } ?>

    <meta name="apple-mobile-web-app-title" content="Solar Power">
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

    <link rel="apple-touch-icon" href="assets/favicons/icon-167.png">

    <link rel="icon" href="assets/favicons/sun.svg" type="image/svg+xml">

    <link rel="stylesheet" type="text/css" href="assets/css/bootstrap-icons.css">
    <link rel="stylesheet" type="text/css" href="assets/css/bootstrap.min.css">
    <link rel="stylesheet" type="text/css" href="assets/css/styles.css">

</head>

<body>

<div class="container">
    <div class="row g-3 g-md-4">  

        <div class="col-8 pt-3 pt-md-5 mb-0 mb-md-0">
            <h3 class="mb-0">Solar Power </h3>
        </div>

        <div class="col-4 pt-3 pt-md-5 text-end d-md-block">
            <p class="mt-auto small pt-1">
                <a href="./?day=<?php echo $one_day_before ?>" class="ms-2" id="prev_day"><i class="bi bi-chevron-left"></i></a>
                <a href="./" class="ms-2">Heute</a>
                <a href="#" class="ms-2 d-none"><i class="bi bi-calendar3"></i></a>
                <a href="./?day=<?php echo $one_day_after ?>"" class="ms-2" id="next_day"><i class="bi bi-chevron-right"></i></a>
            </p>
        </div>

        <div class="col-12 col-md-8 mb-0 mb-md-0 mt-0"><h3><span class="text-muted"><?php echo $dateFormatted; ?><span></h3></div>
             
         <div class="col-12">
            <div class="row g-3 g-md-4">

            <?php if ($selected_day == $date_today) { ?>
                <div class="col-12 col-md-4 mb-0">
                    <div class="box bg-white">
                        <p class="text-muted small"><i class="bi bi-sun"></i> Aktuell <?php echo $lastreload; ?></p>
                        <h1 class="text-center display-3 mb-0"><?php echo $p;?></h1>
                        <p class="text-center">W</p>
                    </div>
                </div>

                <div class="col-12 col-md-4 mb-0">
                    <div class="box bg-white">
                        <p class="text-muted small"><i class="bi bi-sun"></i> <?php echo $daylabel; ?></p>
                        <h1 class="text-center display-3 mb-0"><?php echo $total_sun_day;?></h1>
                        <p class="text-center">kwh</p>
                    </div>
                </div>

                <div class="col-12 col-md-4 mb-0">
                    <div class="box bg-white">
                        <p class="text-muted small"><i class="bi bi-sun"></i> Monat</p>
                        <h1 class="text-center display-3 mb-0"><?php echo $total_sun_month;?></h1>
                        <p class="text-center">kwh</p>
                    </div>
                </div> 
                <?php } else { ?>
                    <div class="col-12 mb-0">
                    <div class="box bg-white">
                        <p class="text-muted small"><i class="bi bi-sun"></i> <?php echo $daylabel; ?></p>
                        <h1 class="text-center display-3 mb-0"><?php echo $total_sun_day;?></h1>
                        <p class="text-center">W</p>
                    </div>
                </div>
                <?php } ?>

            </div>
        </div>


        <div class="col-12 mb-0">
            <div class="box chartbox bg-white">
                <p class="text-muted small"><i class="bi bi-sun"></i> <?php echo $daylabel; ?></p>
                <div class="chart" id="powertodaysun"></div>
            </div>
        </div>

       
        <div class="col-12 mb-0">
            <div class="box chartbox bg-white">
                <p class="text-muted small">Monatsübersicht <?php echo $currentmonth; ?></p>
                <div class="chart" id="chartmonth"></div>
            </div>
        </div>

        <div class="col-12 mb-0 pb-5 mb-0">
            <div class="box chartbox bg-white">
                <p class="text-muted small">Jahresübersicht <?php echo $currentyear; ?></p>
                <div class="chart" id="chartyear"></div>
            </div>
        </div>
    </div>
</div>

    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <script type="text/javascript" src="assets/js/jquery.js"></script>
    <script type="text/javascript" src="assets/js/swipe.js"></script>
    <script type="text/javascript" src="assets/js/bootstrap.min.js"></script>


    <script>
    $(window).bind('focus', function(){
        if ($('body').width() < 800 ){
            window.location.reload(true);
        }
    });    

    $("body").onSwipe(function(results){
        if(results.right == true)
            window.location = "./?day=<?php echo $one_day_before ?>";
        if(results.left == true)
            window.location = "./?day=<?php echo $one_day_after ?>";
    });

    </script>

<?php 

$power_data_store = new \SleekDB\Store("power_data", $databaseDirectory);
$data = $power_data_store->findBy(["date", "=", $selected_day],["_id" => "asc"]);
$data = $data[0];

$chartdata = "";

foreach ($data as $key => $entry) {
    if (is_array($entry) && isset($entry["e"])) {
    $timeString = $entry['time'];
    list($hours, $minutes) = explode('.', $timeString);
    $hours = intval($hours);
    $minutes = intval($minutes);
    $timeArray = array($hours, $minutes, 0);
    $chartdata .= 'data.addRow([['.$hours.','.$minutes.', 0], '.$entry["p"].']);
    ';
    }
}

?>

<script type="text/javascript">
google.charts.load('current', {'packages':['corechart']});
google.charts.setOnLoadCallback(drawPowertoday);

function drawPowertoday() {
    var data = new google.visualization.DataTable();

    data.addColumn('timeofday', 'Uhr');
    data.addColumn('number', 'Sonne');

    <?php echo $chartdata; ?>

    var options = {
    hAxis: {title: ''},
    vAxis: {viewWindowMode: 'pretty',title: 'W'}, //viewWindow: { min: 0}
    colors: ['#c0392b','#576574'],
    pointSize: 2,
    pointsVisible: true,
    chartArea: {left: 50,top: 30,right: 50,bottom: 30,width: '100%',height: '100%'},
    fontName: 'Inter',
    animation: {duration: 1000,startup: true,easing: 'out'},
    curveType: 'function',
    //legend: 'none'
  };
  var chart = new google.visualization.LineChart(document.getElementById('powertoday'));
  chart.draw(data, options);

}

</script>

<?php 
$power_data_store = new \SleekDB\Store("power_data", $databaseDirectory);
$data = $power_data_store->findBy(["date", "=", $selected_day],["_id" => "asc"]);
$data = $data[0];

$chartdata = "";

foreach ($data as $key => $entry) {
    if (is_array($entry) && isset($entry["e"])) {
        $timeString = $entry['time'];
        list($hours, $minutes) = explode('.', $timeString);
        $hours = intval($hours);
        $minutes = intval($minutes);
        $timeArray = array($hours, $minutes, 0);
        if ($entry["p"]){
            $chartdata .= 'data.addRow([['.$hours.','.$minutes.', 0], '.$entry["p"].']);
            ';
        }
    }
}

?>

<script type="text/javascript">
google.charts.setOnLoadCallback(drawPowerTodaySun);

function drawPowerTodaySun() {
    var data = new google.visualization.DataTable();

    data.addColumn('timeofday', 'Uhr');
    data.addColumn('number', 'Sonne');

    <?php echo $chartdata; ?>

    var options = {
    hAxis: {title: ''},
    vAxis: {viewWindowMode: 'explicit',viewWindow: { min: 0 },title: 'W'},
    colors: ['#c0392b'],
    pointSize: 2,
    pointsVisible: true,
    chartArea: {left: 50,top: 30,right: 50,bottom: 30,width: '100%',height: '100%'},
    fontName: 'Inter',
    animation: {duration: 1000,startup: true,easing: 'out'},
    curveType: 'function',
  };
  var chart = new google.visualization.LineChart(document.getElementById('powertodaysun'));
  chart.draw(data, options);

}

</script>



<?php

$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);
$data = $currentstore->findBy(["month", "=", $monthtoday],["_id" => "desc"]);
$data = $data[0];

$days_in_month = cal_days_in_month(CAL_GREGORIAN, date('m'), date('Y'));
$day_data = "";
$total_sun_day = 0;

for ($day = 1; $day <= $days_in_month; $day++) {
    $day_str = ($day < 10) ? '0' . $day : $day;
    $key = $monthtoday . '-' . $day_str;

    if (isset($data[$key])) {
        $total_sun_day = $data[$key]['total_sun_day'];
    } else {
        $total_sun_day = 0;
    }

    $day_data .= "['$day_str', $total_sun_day],\n";
}
?>

<script>
google.charts.load("current", {packages: ["corechart"]});
google.charts.setOnLoadCallback(drawChartMonth);

function drawChartMonth() {

    var monthdata = google.visualization.arrayToDataTable([
        ['Tag', 'Sonne'],
        <?php echo $day_data; ?>
        ]);

    var options = {
    vAxis: {title: 'kwh'},
    seriesType: 'bars', // Specify stacked bars

    colors: ['#c0392b'],
    chartArea:{left:50,top:30,right:90,bottom:30,width:"100%",height:"100%"},
    fontName:'Inter',
    animation:{
            duration: 1000,
            startup: true,
            easing: 'out',
        },
        isStacked: true, 

    };

    var visualization = new google.visualization.ColumnChart(document.getElementById('chartmonth'));
    visualization.draw(monthdata, options);

}

</script>

<?php 
$currentstore = new \SleekDB\Store("power_data_daily", $databaseDirectory);

$yeartoday = date("Y");
$monthNames = ['01' => 'Jan', '02' => 'Feb', '03' => 'Mär', '04' => 'Apr', '05' => 'Mai', '06' => 'Jun', '07' => 'Jul', '08' => 'Aug', '09' => 'Sep', '10' => 'Okt', '11' => 'Nov', '12' => 'Dez'];

$data = $currentstore->findBy(["month", "like", $yeartoday."-".$month ],["_id" => "desc"]);

$chartdata = "";


for ($i = 1; $i <= 12; $i++) {
    $month = str_pad($i, 2, '0', STR_PAD_LEFT); 
    $monthName = $monthNames[$month];

    $data = $currentstore->findBy(["month", "like", $yeartoday."-".$month ],["_id" => "desc"]);

        if (substr($data[0]["month"], -2) === ''.$month.'') {
            
            $total_sun_month = $data[0]['total_sun_month'];
            
        } else {
            $total_sun_month = 0;
            
        }
    $chartdata .= "['$monthName', $total_sun_month],\n";
}
?>

<script>

google.charts.load("current", {packages: ["corechart"]});
google.charts.setOnLoadCallback(drawChartYear);

function drawChartYear() {

    var monthdata = google.visualization.arrayToDataTable([
        ['Monat', 'Sonne'],
        <?php echo $chartdata; ?>
        ]);

    var options = {
    vAxis: {title: 'kwh'},
    colors: ['#c0392b'],
    chartArea:{left:50,top:30,right:90,bottom:30,width:"100%",height:"100%"},
    fontName:'Inter',
    isStacked: true, // Aktiviere gestapelte Balken
    animation:{
            duration: 1000,
            startup: true,
            easing: 'out',
        }
    };

    var visualization = new google.visualization.ColumnChart(document.getElementById('chartyear'));
    visualization.draw(monthdata, options);

}
</script>

</body>
</html>